//
//  dTouchViewController.m
//  dTouch
//
//  Created by Dustin O'Connor on 9/6/09.
//  Copyright umaine 2009. All rights reserved.
//

#import "dTouchViewController.h"

#import "BBOSCArgument.h"
#import "BBOSCListener.h"
#import "BBOSCDispatcher.h"
#import "BBOSCDataUtilities.h"
#import "BBOSCMessage.h"
#import "BBOSCBundle.h"
#import "BBOSCDecoder.h"
#import "BBOSCSender.h"
#import "BBOSCAddress.h"


@implementation dTouchViewController

@synthesize textField;
//@synthesize label;
@synthesize string;

@synthesize oscListener;
@synthesize oscSender;

- (void)viewDidLoad {
    // When the user starts typing, show the clear button in the text field.
    textField.clearButtonMode = UITextFieldViewModeWhileEditing;
    // When the view first loads, display the placeholder text that's in the
    // text field in the label.
   // label.text = textField.placeholder;
	
	
	
	NSString* myString = [NSString string];
	myString = textField.placeholder;
	
	//@"76.179.16.207"
	
	[self setOscListener:[BBOSCListener defaultListenerOnPort:6666]];
	[self setOscSender:[BBOSCSender senderWithDestinationHostName:myString portNumber:6666]];
	
	
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationLandscapeRight);}
	


- (void)updateString {
	
	// Store the text of the text field in the 'string' instance variable.
	self.string = textField.text;
    // Set the text of the label to the value of the 'string' instance variable.
	//label.text = self.string;
	
	[self setOscSender:[BBOSCSender senderWithDestinationHostName:self.string portNumber:6666]];
}


- (BOOL)textFieldShouldReturn:(UITextField *)theTextField {
	// When the user presses return, take focus away from the text field so that the keyboard is dismissed.
	if (theTextField == textField) {
		[textField resignFirstResponder];
        // Invoke the method that changes the greeting.
        [self updateString];
	}
	return YES;
}




- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
	
	
	// Dismiss the keyboard when the view outside the text field is touched.
    [textField resignFirstResponder];
    // Revert the text field to the previous value.
    textField.text = self.string; 
	
	
    [super touchesBegan:touches withEvent:event];
	
	BBOSCMessage * tap = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/dust/tap/count/"]];
	
    UITouch* touch = [touches anyObject];
    NSUInteger numTaps = [touch tapCount];
	
	[tap attachArgument:[BBOSCArgument argumentWithInt:numTaps]];
	
	if (![[self oscSender] sendOSCPacket:tap]) {
		NSLog(@"Oh Noes!!");
	}
	
	
	
    if (numTaps < 2) {
        [self.nextResponder touchesBegan:touches withEvent:event];
		NSLog(@"single tap");
		
		
	} else {
		
		
		NSLog(@"double tap");
		
		BBOSCMessage * dp = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/dust/double/tap/"]];
		[dp attachArgument:[BBOSCArgument argumentWithFloat:1.0]];
	}
	
	NSUInteger touchCount = 0;

	for (UITouch *touch in touches) {
		touchCount++;
	}
	
	if (touchCount==1) {
		

		UITouch* touch = [[touches allObjects] objectAtIndex:0];
		CGPoint currentTouchPosition1 = [touch locationInView:self.view];
		
		NSLog(@"x1 %f ", currentTouchPosition1.x);
		NSLog(@"y1 %f ", currentTouchPosition1.y);
		
		BBOSCMessage * t1 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/dust/start/touch1/"]];
		
		
		[t1 attachArgument:[BBOSCArgument argumentWithInt:1]];
		[t1 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.x]];	
		[t1 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.y]];		
		
		
		if (![[self oscSender] sendOSCPacket:t1]) {
			NSLog(@"Oh Noes!!");
		}
	}
	
	
	else if (touchCount==2) {
		
		
	
		
		UITouch* touch = [[touches allObjects] objectAtIndex:0];
		CGPoint currentTouchPosition1 = [touch locationInView:self.view];
		
		UITouch* touch2 = [[touches allObjects] objectAtIndex:1];
		CGPoint currentTouchPosition2 = [touch2 locationInView:self.view];
		
		
		NSLog(@"x1 %f ", currentTouchPosition1.x);
		NSLog(@"y1 %f ", currentTouchPosition1.y);
		
		NSLog(@"x2 %f ", currentTouchPosition2.x);
		NSLog(@"y2 %f ", currentTouchPosition2.y);
		
		
		BBOSCMessage * t2 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/dust/start/touch2/"]];
		
		[t2 attachArgument:[BBOSCArgument argumentWithInt:2]];
		
		[t2 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.x]];	
		[t2 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.y]];		
		
		
		[t2 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition2.x]];	
		[t2 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition2.y]];	
		
		
		
		
		if (![[self oscSender] sendOSCPacket:t2]) {
			NSLog(@"Oh Noes!!");
		}
		
	}
	
	else if (touchCount==3) {
		

		
		UITouch* touch = [[touches allObjects] objectAtIndex:0];
		CGPoint currentTouchPosition1 = [touch locationInView:self.view];
		
		UITouch* touch2 = [[touches allObjects] objectAtIndex:1];
		CGPoint currentTouchPosition2 = [touch2 locationInView:self.view];
		
		UITouch* touch3 = [[touches allObjects] objectAtIndex:2];
		CGPoint currentTouchPosition3 = [touch3 locationInView:self.view];
		
		NSLog(@"x1 %f ", currentTouchPosition1.x);
		NSLog(@"y1 %f ", currentTouchPosition1.y);
		
		NSLog(@"x2 %f ", currentTouchPosition2.x);
		NSLog(@"y2 %f ", currentTouchPosition2.y);
		
		NSLog(@"x3 %f ", currentTouchPosition3.x);
		NSLog(@"y3 %f ", currentTouchPosition3.y);
		
		BBOSCMessage * t3 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/dust/start/touch3/"]];
		
		[t3 attachArgument:[BBOSCArgument argumentWithInt:3]];
		
		[t3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.x]];	
		[t3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.y]];		
		
		
		[t3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition2.x]];	
		[t3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition2.y]];		
		
		[t3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition3.x]];	
		[t3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition3.y]];	
		
		
		if (![[self oscSender] sendOSCPacket:t3]) {
			NSLog(@"Oh Noes!!");
		}
		
		
		
	}
	
	else {
		NSLog(@"touches <1 || >3");
	}
	
}
- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
	
	NSUInteger touchCount = 0;
	
	for (UITouch *touch in touches) {
		touchCount++;
	}
	
	
	
	if (touchCount==1) {
		
		UITouch* touch = [[touches allObjects] objectAtIndex:0];
		CGPoint currentTouchPosition1 = [touch locationInView:self.view];
		
	
		
		NSLog(@"x1 %f ", currentTouchPosition1.x);
		NSLog(@"y1 %f ", currentTouchPosition1.y);
		
		BBOSCMessage * tm1 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/dust/move/touch1/"]];
		
		[tm1 attachArgument:[BBOSCArgument argumentWithInt:1]];
		
		[tm1 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.x]];	
		[tm1 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.y]];	
		
		
		if (![[self oscSender] sendOSCPacket:tm1]) {
			NSLog(@"Oh Noes!!");
		}
	}
	
	
	else if (touchCount==2) {
		

		
		UITouch* touch = [[touches allObjects] objectAtIndex:0];
		CGPoint currentTouchPosition1 = [touch locationInView:self.view];
		
		UITouch* touch2 = [[touches allObjects] objectAtIndex:1];
		CGPoint currentTouchPosition2 = [touch2 locationInView:self.view];
		
		
		NSLog(@"x1 %f ", currentTouchPosition1.x);
		NSLog(@"y1 %f ", currentTouchPosition1.y);
		
		NSLog(@"x2 %f ", currentTouchPosition2.x);
		NSLog(@"y2 %f ", currentTouchPosition2.y);
		
		BBOSCMessage * tm2 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/dust/move/touch2/"]];
		
		[tm2 attachArgument:[BBOSCArgument argumentWithInt:2]];
		
		
		[tm2 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.x]];	
		[tm2 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.y]];
		
		[tm2 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition2.x]];	
		[tm2 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition2.y]];	
		
		
		if (![[self oscSender] sendOSCPacket:tm2]) {
			NSLog(@"Oh Noes!!");
		}
		
		
		
	}
	
	else if (touchCount==3) {
		
		UITouch* touch = [[touches allObjects] objectAtIndex:0];
		CGPoint currentTouchPosition1 = [touch locationInView:self.view];
		
		UITouch* touch2 = [[touches allObjects] objectAtIndex:1];
		CGPoint currentTouchPosition2 = [touch2 locationInView:self.view];
		
		UITouch* touch3 = [[touches allObjects] objectAtIndex:2];
		CGPoint currentTouchPosition3 = [touch3 locationInView:self.view];
		
		NSLog(@"x1 %f ", currentTouchPosition1.x);
		NSLog(@"y1 %f ", currentTouchPosition1.y);
		
		NSLog(@"x2 %f ", currentTouchPosition2.x);
		NSLog(@"y2 %f ", currentTouchPosition2.y);
		
		NSLog(@"x3 %f ", currentTouchPosition3.x);
		NSLog(@"y3 %f ", currentTouchPosition3.y);
		
		
		BBOSCMessage * tm3 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/dust/move/touch3/"]];
		
		[tm3 attachArgument:[BBOSCArgument argumentWithInt:3]];
		
		
		[tm3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.x]];	
		[tm3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition1.y]];
		
		
		[tm3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition2.x]];	
		[tm3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition2.y]];		
		
		
		
		[tm3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition3.x]];	
		[tm3 attachArgument:[BBOSCArgument argumentWithFloat:currentTouchPosition3.y]];	
		
		
		
		
		if (![[self oscSender] sendOSCPacket:tm3]) {
			NSLog(@"Oh Noes!!");
		}
		
		
	}
	
	else {
		NSLog(@"touches <1 || >3");
		
	}
	
	
}


- (void)dealloc {
	// To adhere to memory management rules, release the instance variables.
    // 'textField' and 'label' are objects in the nib file and are created when the nib
    // is loaded.
	[textField release];
	//[label release];
	[super dealloc];
}




/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}




@end
